-- Latest version of YDBR is always available at http://www.unrealsoftware.de/files_show.php?file=17455 !
print("Latest version of YDBR is always available at http://www.unrealsoftware.de/files_show.php?file=17455 !")

math.randomseed(os.time())
-- Settings
casual = false -- Casual mode? (100 armor+defuse kits on spawn, halved kill reward)
-- Random Assign Teams
randomassignteams = true -- Randomly reassign teams after x rounds(set below)?
if randomassignteams then roundsbeforerearrange = 16 end -- How many rounds should be waited to reassign all the players?
-- Auto Refill Weapons
arw = true -- refill weapons (and armor+defuse kits)?
ignores = {50, 69, 74, 78, 85, 51, 52, 53, 54, 72, 73, 75, 76, 86, 89, 77, 67, 55, 41} -- Items to be ignored
-- You saved somebody
yss = true -- Message when you saved someone?
messagechance = 25 -- The chance of the message appearing when it meets the requirement
second_before_reset = 3 -- Seconds before resetting lasthit data
messageself = false -- Should the message appear if you saved yourself?

reward = false -- Ohhhhhh, reward! Sweet!
rewarditems = {51, 52, 53, 58, 61, 65} -- Default items are usual grenades and ammunitions
rewardchance = 25 -- Chance of rewarding
rewardself = false -- Oh my god I got a reward for defending myself!
rewardforteamkill = false -- Should a traitor/self defense be rewarded?
-- Custom Kill Reward
killreward = true -- Should the server use custom kill awards?
killrewardmoney = { -- You can specify a specific weapon reward, names should be in lower caps
["knife"]			= 500, -- Due to CS2D's characteristics, it is 500, original is 1500
["machete"]			= 300,
["claw"]			= 300,
["chainsaw"]		= 200,
["p90"]				= 300,
["awp"]				= 200,
["gas grenade"] 	= 100,
["snowball"]		= 300,
["air strike"]		= 100,
["gut bomb"]		= 300,
["satchel charge"]	= 100,
["pistol"]			= 400,
["shotgun"]			= 300, -- Due to CS2D's characteristics, it is 300, default is 900
["smg"]				= 400,
["grenade"]			= 300,
["rifle"]			= 300,
["hmg"]				= 300,
["special"]			= 200, -- ID = 45 - 49
["mines"]			= 300
}
-- Damage Drop
damagedrop = true -- Damage drop based on distance?
if damagedrop then nodropdis = 15 -- tiled based distance; specifies the distance where damage will never drop
randomdamagedrop = true -- additional drop?
randomdropmax = 2 -- maximum additional drop
dropmultiplier = true -- randomize the drop ammount?
if not dropmultiplier then dropmult = 1 end
end

-- Initialization, nothing to be changed
if randomassignteams then assign_teams = {"t", "ct"}
roundstarted = 0 end
if yss then lasthit = {}
for i = 1, game("sv_maxplayers") do lasthit[i] = {} lasthit[i][1], lasthit[i][2] = 0, second_before_reset end
second_count = 0 end
if damagedrop then grentable = {51, 72, 73, 89, 77, 87, 49} end

-- These are hooks
if randomassignteams then addhook("startround", "_startround") end
if yss or arw then addhook("spawn", "_spawn") end
if randomassignteams then addhook("parse", "_parse") end
if yss or damagedrop then addhook("hit", "_hit") addhook("second", "_second") end
if yss or killreward then addhook("kill", "_kill") end

-- These are main code.

if yss then function lasthitinit(p)
	lasthit[p][1], lasthit[p][2] = 0, second_before_reset
end
end

if damagedrop then function distance(x1, x2, y1, y2) -- god damn distance formula
	return math.sqrt((x2-x1)^2 + (y2-y1)^2)
end
end

if randomassignteams then function _startround()
	if roundstarted == roundsbeforerearrange then randomassign()
	else roundstarted = roundstarted + 1 parse('hudtxt 1 \"\169255255255Rounds left: '..(roundsbeforerearrange-roundstarted)..'\" 9 424 0') end
	if casual then parse('hudtxt 2 "\169255255255Casual Mode" 120 424 0') else parse('hudtxt 2 "\169255255255Competitive Mode" 120 424 0') end
end
end

if yss then function _second()
	for i = 1, #player(0, "tableliving") do
		if lasthit[player(0, "tableliving")[i]][2] > 0 then lasthit[player(0, "tableliving")[i]][2] = lasthit[player(0, "tableliving")[i]][2] - 1
		elseif lasthit[player(0, "tableliving")[i]][2] ~= -1 then lasthitinit(player(0, "tableliving")[i]) end
	end
end
end

if not rewardforteamkill then function checkteam(p, v)
	if player(p, "team") ~= player(v, "team") then return true else return false end
end
end

if reward then function checkreward(p, v)
	local rewardc = math.random(1, 100)
	if rewardc <= rewardchance then
		if rewardself then giftitem(p)
		elseif rewardforteamkill then giftitem(p)
		elseif checkteam(p, v) then giftitem(p) end
	end
end
end

if reward then function giftitem(p)
	local t = math.random(1, #rewarditems)
	parse("equip "..p.." "..rewarditems[t])
	msg2(p, "\169092172238You have been rewarded a "..itemtype(rewarditems[t], "name").."!")
end
end

if randomassignteams then function randomassign()
	local playert = player(0, "table")
	local opponentteam = 0
	local teamname
	msg("\169255255255Teams are being randomly assigned!")
	for i = 1, #playert do
		parse("makespec "..playert[i]) -- This is necessary.
	end
	for i = 1, #playert do
		local theteam = math.random(1, 2)
		if theteam == 1 then
			opponentteam = 2
		else
			opponentteam = 1
		end
		if #player(0, "team"..theteam) <= #player(0, "team"..opponentteam) then
			teamname = assign_teams[theteam]
		else
			teamname = assign_teams[opponentteam]
		end
		parse("make"..teamname.." "..playert[i])
	end
	roundstarted = 0
	print("\169255255255Teams randomly assigned!")
end
end

if randomassignteams then function _parse(t)
	if t == "assignteams" then randomassign() return 2 end
	if t == "casual" then if casual then casual = false parse('hudtxt 2 "\169255255255Competitive Mode" 120 424 0') else casual = true parse('hudtxt 2 "\169255255255Casual Mode" 120 424 0') end end 
end
end

if arw then function weptts(p)
	local str = p[1]
	for i = 2, #p do
		str = str..", "..p[i]
	end
	return str
end
end

if yss or arw then function _spawn(p)
	if yss then lasthitinit(p) end
	if arw then local wep = playerweapons(p)
	for i = 1, #ignores do
		for k = 1, #wep do
			if wep[k] == ignores[i] then table.remove(wep, k) end
		end
	end
	if casual then
		parse("setarmor "..p.. " 100")
		if player(p, "team") == 2 and game("sv_map"):sub(1,3) == "de_" and not player(p, "defusekit")  then -- this is a lazy approach, searching for non-deadly tiles are too tiring
			parse("spawnitem 56 "..player(p, "tilex").." "..player(p, "tiley"))
			local x, y = player(p, "tilex"), player(p, "tiley")
			parse("setpos "..p.." "..(player(p, "tilex") + 0.5) * 32 + 16 .." ".. (player(p, "tiley") + 0.5) * 32 + 16)
			parse("setpos "..p.." "..x * 32 + 16 .." ".. y * 32 + 16)
		end
	end
	return weptts(wep)
end
end
end

if damagedrop then function notgrenade(x)
	for i = 1, #grentable do
		if x == i then return false end
	end
	return true
end
end

if yss or damagedrop then function _hit(v, p, w, h, a)
	if yss then lasthit[p][1], lasthit[p][2] = v, second_before_reset end
	if damagedrop and notgrenade(w) then
		local d = distance(player(p, "tilex"), player(v, "tilex"), player(p, "tiley"), player(v, "tiley"))
		if d <= nodropdis then return 0
		else
			if dropmultiplier then local dropmult = 1 + math.random(0, 2)* 0.1 end
			h, a = h - (h*d*dropmult/100), a - (a*d*dropmult/100)
			if randomdamagedrop then
				h, a = math.random(h, h + randomdropmax), math.random(a, a + randomdropmax)
			end
			parse("sethealth "..v.." "..(player(v, "health")-h)) parse("setarmor "..v.." "..(player(v, "armor")-a)) return 1
		end
	end
	return 0
end
end

if killreward then function checkweapon(w)
	local wpntype
	if w >= 1 and w <= 6 then wpntype = killrewardmoney["pistol"]
	elseif w == 10 or w == 11 then wpntype = killrewardmoney["shotgun"]
	elseif w >=  20 and w <= 24 then wpntype = killrewardmoney["smg"]
	elseif (w >= 30 and w <= 39) or w == 91 then wpntype = killrewardmoney["rifle"]
	elseif w == 40 or w == 90 then wpntype = killrewardmoney["hmg"]
	elseif w >= 45 and w <= 49 then wpntype = killrewardmoney["special"]
	elseif w == 51 or w == 73 then wpntype = killrewardmoney["grenade"]
	elseif w == 77 or w == 87 then wpntype = killrewardmoney["mines"]
	end
	return wpntype
end
end

if yss or killreward then function _kill(p, v, w)
	if killreward then
		local money = player(p, "money") - 300
		parse("setmoney "..p.." "..money)
		if killrewardmoney[string.lower(itemtype(w, "name"))] then money = killrewardmoney[string.lower(itemtype(w, "name"))]
		else money = checkweapon(w)
		end
		if casual then money = money/2 end
		parse("setmoney "..p.." "..(player(p, "money") + money))
	end
	if yss then local target = lasthit[v][1]
	local mchance = math.random(1, 100)
	if target ~= 0 and mchance <= messagechance and player(target, "health") > 0 then
		if target ~= p  then
			msg2(p, "\169154205050** You just saved \169255255255"..player(target, "name").." \169154205050from \169255255255"..player(v, "name").." \169154205050**")
			msg2(target, "\169154205050** \169255255255"..player(p, "name").." \169154205050just saved you from \169255255255"..player(v, "name").." \169154205050**")
		elseif messageself then
			msg2(p, "\169154205050** You just saved yourself from \169255255255"..player(v, "name").." \169154205050**")
		end
	if reward then checkreward(p, v) end
	end
end
end
end